# 1.0 (2015-05-08) #

Reworked

* Fully reworked. Refer to README for documentation on the new router.

Major bugfixes

* Fixed the error message (and subsequent die() statement) when the log level is set to LOG_LEVEL_DEBUG.

Misc bugfixes

* Changed the event definition in setup/create_session_table_and_cleaner.sql to use the correct table name
* Debug output in MemcachedWrapper->getAllMemcache() removed
* Logger & error handler paths fixed for PHPUNIT
* Cookie clease tweaked for PHPUNIT
* Fixed exception throwing if-else order in MemcachedSession. It now makes sure the MemcachedWrapper class is loaded and all its static properties are loaded before calling is_available()
* Fixed multiple validation errors in the testing suite
* Crontab should now correctly reload if it fetches an empty string
* Fixed code line detection in log messages

Added features

* It's now possible to force a session write operation during runtime via AbstractSession->forceWrite()
* clear(), getTokenExpected() and getTokenActual() and refreshToken() added to AbstractSession
* clearCrontab() method at crontab editor
* Possibility to automatically commit crontab changes. Use with caution!
* getAtIndex() method in Cron
* \Alo\Statics\Security class added
* __isset() and __unset() added to all classes that had __get() or __set() defined
* \Alo\Statics\Format::is_ipv4_ip() method added

Removed items

* Format::isBoolean()

Miscellaneous

* Switched to ApiGen as the code documentation provider
* SQLSession now uses the ALO_SESSION_TABLE_NAME instead of self::TABLE_NAME
* json encode/decode removed from MemcachedSession write/fetch()
* FormValidator documentation edit
* Cron editor now throws an exception if you try to invoke it on a Windows machine
* PHPUNIT_RUNNING constant definition moved out of source code. It now simply checks if the constant is defined in the bootstrap file.
* The global functions getFingerprint(), getUniqid(), escape() moved to \Alo\Statics\Security. The escape() function has been renamed to un_xss() in the class.
* DIR_CONTROLLERS constant added

# 0.2.1 (2015-05-05) #
Major bugfixes

* Fixed error where config files wouldn't be loaded correctly
* Fixed errors with the legacy Memcache getAll() alternative

Misc bugfixes

* Fixed router so it doesn't mistake an in-app ReflectionException with one that's caused by trying to initialise an invalid controller/method
* Added chdir() in index.php if it's a CLI request to be completely sure the path is correct for CLI requests.
* Debug backtrace removed from error controller
* \debug() output removed from MemcachedWrapper->getAllMemcache()

Added features

* Added an option in the router to initialise without attempting to call the controller
* __get() and __set() methods in AbstractCache
* It's now possible to get the last hash generated by AbstractDB via the getLastHash() method

Other

* PHPUNIT_RUNNING constant introduced for when you're running PHPUnit tests. This alters the automatic code flow in the sys files so they do not interfere.
* Realised that array shorthands were introduced in 5.4, not 5.3, so the framework description needs some updating...

# 0.2 (2015-05-04) #
* Trait support added - see app/traits
* Kint external library updated
* Slashes in paths replaced with DIRECTORY_SEPARATOR
* Profiling class added
* The Router now has a lot more getters
* Error, autoloading and exception handlers moved to \Alo\Handler
* Committed function tester (forgot about it earlier)
* Fixed an error where any uncaught exception would force the 404 error page.
* Many more statics added to \Alo
* Error divs prettified